/* MySpyDlg.cpp - Demonstration application for sending windows events.
 * Copyright (c) 2001-2003 Simos Xenitellis <simos74@gmx.net>
 *
 * -----------------------------------------------------------------------
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * The GNU General Public License is available from http://www.gnu.org/ or
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 * -----------------------------------------------------------------------
 */

#include "stdafx.h"
#include "MySpy.h"
#include "MySpyDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#undef THIS_FILE
static char THIS_FILE[] = __FILE__;
#endif

/////////////////////////////////////////////////////////////////////////////
// CAboutDlg dialog used for App About

class CAboutDlg : public CDialog
{
public:
	CAboutDlg();

// Dialog Data
	//{{AFX_DATA(CAboutDlg)
	enum { IDD = IDD_ABOUTBOX };
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CAboutDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);    // DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	//{{AFX_MSG(CAboutDlg)
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
};

CAboutDlg::CAboutDlg() : CDialog(CAboutDlg::IDD)
{
	//{{AFX_DATA_INIT(CAboutDlg)
	//}}AFX_DATA_INIT
}

void CAboutDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CAboutDlg)
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CAboutDlg, CDialog)
	//{{AFX_MSG_MAP(CAboutDlg)
		// No message handlers
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMySpyDlg dialog

CMySpyDlg::CMySpyDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CMySpyDlg::IDD, pParent)
{
	//{{AFX_DATA_INIT(CMySpyDlg)
	m_cstrCurrentClassName = _T("");
	m_cstrCurrentHWnd = _T("");
	m_cstrCurrentText = _T("");
	m_strExecuteAddress = _T("");
	m_strSetCaption = _T("");
	m_strSetWindow = _T("");
	m_cstrCurrentUser = _T("");
	m_cstrWinStationDesktop = _T("");
	//}}AFX_DATA_INIT
	// Note that LoadIcon does not require a subsequent DestroyIcon in Win32
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CMySpyDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	//{{AFX_DATA_MAP(CMySpyDlg)
	DDX_Control(pDX, IDC_EDIT_BRINGPASSWORD, m_cBringPassword);
	DDX_Text(pDX, IDC_EDIT_CURRCLASSNAME, m_cstrCurrentClassName);
	DDV_MaxChars(pDX, m_cstrCurrentClassName, 256);
	DDX_Text(pDX, IDC_EDIT_CURRHWND, m_cstrCurrentHWnd);
	DDV_MaxChars(pDX, m_cstrCurrentHWnd, 256);
	DDX_Text(pDX, IDC_EDIT_CURRTEXT, m_cstrCurrentText);
	DDV_MaxChars(pDX, m_cstrCurrentText, 256);
	DDX_Text(pDX, IDC_EXECUTEADDRESS, m_strExecuteAddress);
	DDV_MaxChars(pDX, m_strExecuteAddress, 30);
	DDX_Text(pDX, IDC_SETCAPTION, m_strSetCaption);
	DDV_MaxChars(pDX, m_strSetCaption, 1024);
	DDX_Text(pDX, IDC_EDIT_SETWINDOW, m_strSetWindow);
	DDV_MaxChars(pDX, m_strSetWindow, 12);
	DDX_Text(pDX, IDC_EDIT_CURRENTUSER, m_cstrCurrentUser);
	DDV_MaxChars(pDX, m_cstrCurrentUser, 128);
	//}}AFX_DATA_MAP
}

BEGIN_MESSAGE_MAP(CMySpyDlg, CDialog)
	//{{AFX_MSG_MAP(CMySpyDlg)
	ON_WM_SYSCOMMAND()
	ON_WM_PAINT()
	ON_WM_QUERYDRAGICON()
	ON_BN_CLICKED(IDC_BUTTON_CLOSE_WINDOW, OnButtonCloseWindow)
	ON_WM_DESTROY()
	ON_BN_CLICKED(IDC_BUTTON_REVEALPASS, OnButtonRevealpass)
	ON_BN_CLICKED(IDC_BUTTON_SETPASS, OnButtonSetpass)
	ON_BN_CLICKED(IDC_BUTTON_BRING_PASSWORD, OnButtonBringPassword)
	ON_BN_CLICKED(IDC_BUTTON_SETCAPTION, OnButtonSetCaption)
	ON_BN_CLICKED(IDC_BUTTON_FREEZE_WINDOW, OnButtonFreezeWindow)
	ON_BN_CLICKED(IDC_BUTTON_MELT_WINDOW, OnButtonMeltWindow)
	ON_BN_CLICKED(IDC_BUTTON_ENABLE_OBJECT, OnButtonEnableObject)
	ON_BN_CLICKED(IDC_BUTTON_DISABLE_OBJECT, OnButtonDisableObject)
	ON_BN_CLICKED(IDC_BUTTON_ENABLECLICK, OnButtonEnableAndClick)
	ON_BN_CLICKED(IDC_BUTTON_EXECUTE, OnButtonExecuteAddress)
	ON_EN_UPDATE(IDC_EXECUTEADDRESS, OnUpdateExecuteAddress)
	ON_EN_UPDATE(IDC_SETCAPTION, OnUpdateSetCaption)
	ON_BN_CLICKED(IDC_BUTTON_SETSPYINGWINDOW, OnButtonSetSpyingWindow)
	ON_EN_UPDATE(IDC_EDIT_SETWINDOW, OnUpdateEditSetWindow)
	ON_WM_LBUTTONDOWN()
	ON_WM_LBUTTONUP()
	ON_WM_MOUSEMOVE()
	ON_WM_KILLFOCUS()
	//}}AFX_MSG_MAP
END_MESSAGE_MAP()

/////////////////////////////////////////////////////////////////////////////
// CMySpyDlg message handlers

BOOL CMySpyDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Add "About..." menu item to system menu.

	// IDM_ABOUTBOX must be in the system command range.
	ASSERT((IDM_ABOUTBOX & 0xFFF0) == IDM_ABOUTBOX);
	ASSERT(IDM_ABOUTBOX < 0xF000);

	CMenu* pSysMenu = GetSystemMenu(FALSE);
	if (pSysMenu != NULL)
	{
		CString strAboutMenu;
		strAboutMenu.LoadString(IDS_ABOUTBOX);
		if (!strAboutMenu.IsEmpty())
		{
			pSysMenu->AppendMenu(MF_SEPARATOR);
			pSysMenu->AppendMenu(MF_STRING, IDM_ABOUTBOX, strAboutMenu);
		}
	}

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	hStatic	= (HWND )::GetDlgItem(m_hWnd, IDC_ICON_CROSSHAIRSTANDBY);
	hIcoCrossHairOff.LoadBitmap(IDB_BITMAP_CROSSHAIROFF);
	hIcoCrossHairOn.LoadBitmap(IDB_BITMAP_CROSSHAIRON);

	// TODO: Add extra initialization here
	m_bChasing = FALSE;
	m_ciNameSize = 256;
	m_lCurrentWnd = (HWND )NULL;
	m_lLastWnd = (HWND )NULL;
	m_lpCurrentClassName = new char[m_ciNameSize];
	m_lpCurrentWindowText = new char[m_ciNameSize];
	
	if ( m_lpCurrentClassName == NULL || m_lpCurrentWindowText == NULL )
	{
		MessageBox("Not enough memory...");
		PostQuitMessage(0);
	}

	SetWindowPos(&wndTopMost, 0,0,0,0, SWP_NOMOVE | SWP_NOSIZE | SWP_SHOWWINDOW ); 

	RetrieveComputerUserName();
	UpdateData(FALSE);

	return TRUE;  // return TRUE  unless you set the focus to a control
}

void CMySpyDlg::OnSysCommand(UINT nID, LPARAM lParam)
{
	if ((nID & 0xFFF0) == IDM_ABOUTBOX)
	{
		CAboutDlg dlgAbout;
		dlgAbout.DoModal();
	}
	else
	{
		CDialog::OnSysCommand(nID, lParam);
	}
}

void CMySpyDlg::OnPaint() 
{
	if (IsIconic())
	{
		CPaintDC dc(this); // device context for painting

		SendMessage(WM_ICONERASEBKGND, (WPARAM) dc.GetSafeHdc(), 0);

		// Center icon in client rectangle
		int cxIcon = GetSystemMetrics(SM_CXICON);
		int cyIcon = GetSystemMetrics(SM_CYICON);
		CRect rect;
		GetClientRect(&rect);
		int x = (rect.Width() - cxIcon + 1) / 2;
		int y = (rect.Height() - cyIcon + 1) / 2;

		// Draw the icon
		dc.DrawIcon(x, y, m_hIcon);
	}
	else
	{
		CDialog::OnPaint();
	}
}

// The system calls this to obtain the cursor to display while the user drags
//  the minimized window.
HCURSOR CMySpyDlg::OnQueryDragIcon()
{
	return (HCURSOR) m_hIcon;
}

// Button #1: Close object
// Event    : WM_CLOSE, 0, 0
void CMySpyDlg::OnButtonCloseWindow() 
{
	::SendMessage( m_lCurrentWnd, WM_CLOSE, 0, 0 );
}

// Button #2: Melt object (text box)
// Event    : EM_SETREADONLY, FALSE, 0
void CMySpyDlg::OnButtonMeltWindow() 
{
	::SendMessage( m_lCurrentWnd, EM_SETREADONLY, FALSE, 0 );
}

// Button #3: Freeze object (text box)
// Event    : EM_SETREADONLY, TRUE, 0
void CMySpyDlg::OnButtonFreezeWindow() 
{
	::SendMessage( m_lCurrentWnd, EM_SETREADONLY, TRUE, 0 );
}

// Button #4: Reveal password (remove the Password property from a text box)
// Event    : EM_SETPASSWORDCHAR, 0, 0
void CMySpyDlg::OnButtonRevealpass() 
{
	::PostMessage( m_lCurrentWnd, EM_SETPASSWORDCHAR, 0, 0 );
}

// Button #5: Hide text (set the Password property on a text box)
// Event    : EM_SETPASSWORDCHAR, '*', 0
void CMySpyDlg::OnButtonSetpass() 
{
	::PostMessage( m_lCurrentWnd, EM_SETPASSWORDCHAR, '*', 0 );
}

// Button #6: Enable object (set the Password property on a text box)
// Event    :
void CMySpyDlg::OnButtonEnableObject() 
{
	// Either these do not enable the object.
	// ::EnableWindow(m_lCurrentWnd, TRUE);
	// ::PostMessage( m_lCurrentWnd, WM_ENABLE, (WPARAM )TRUE, (LPARAM )0 );
//	::MessageBox(NULL, "Enable Object", "Stub", MB_OK);

	// ..........
	// ::PostMessage( m_lCurrentWnd, LMOUSEDOWN, (WPARAM )FALSE, (LPARAM )0 );
	// ::MessageBox(NULL, "Enable And Click", "Stub", MB_OK);
	DWORD dwStyle;
	RECT rc;
	LPARAM longpoint;
	DWORD dwResult;
	
	dwStyle  = ::GetWindowLong(m_lCurrentWnd, GWL_STYLE);
	dwStyle &= ~WS_DISABLED;
	::SetWindowLong(m_lCurrentWnd, GWL_STYLE, dwStyle);
	::SendMessage( m_lCurrentWnd, WM_CHILDACTIVATE, (WPARAM )0, (LPARAM )0 );
	::SendMessage( m_lCurrentWnd, WM_PAINT, (WPARAM )0, (LPARAM )0 );

	// Get location of the observed window.
	if ( ::GetWindowRect(m_lCurrentWnd, &rc) == 0 )
		dwResult = GetLastError(); 

	longpoint = MAKELONG( rc.left + (rc.right - rc.left)/2, rc.top + (rc.bottom - rc.top)/2);

	// We click swiftly so that to repaint the button. The button is not actually clicked.
	::PostMessage( m_lCurrentWnd, WM_LBUTTONDOWN, MK_LBUTTON, longpoint );
	::PostMessage( m_lCurrentWnd, WM_LBUTTONUP, MK_LBUTTON, longpoint );
}

// Button #7: Disable object (Need to have been enabled so that we can get its handle)
// Event    : WM_ENABLE, FALSE, 0
void CMySpyDlg::OnButtonDisableObject() 
{
	// Either these are ok.
	// ::SendMessage( m_lCurrentWnd, WM_ENABLE, (WPARAM )FALSE, (LPARAM )0 );
	::EnableWindow(m_lCurrentWnd, FALSE);
}

// Button #8: Disable object (Need to have been enabled so that we can get its handle)
// Event    : WM_ENABLE, FALSE, 0
// Event    ; WM_LBUTTONDOWN, 0, 0
void CMySpyDlg::OnButtonEnableAndClick() 
{
	// ..........
	// ::PostMessage( m_lCurrentWnd, LMOUSEDOWN, (WPARAM )FALSE, (LPARAM )0 );
	// ::MessageBox(NULL, "Enable And Click", "Stub", MB_OK);
	DWORD dwStyle;
	RECT rc;
	LPARAM longpoint;
	DWORD dwResult;
	
	dwStyle  = ::GetWindowLong(m_lCurrentWnd, GWL_STYLE);
	dwStyle &= ~WS_DISABLED;
	::SetWindowLong(m_lCurrentWnd, GWL_STYLE, dwStyle);
	::SendMessage( m_lCurrentWnd, WM_CHILDACTIVATE, (WPARAM )0, (LPARAM )0 );
	::SendMessage( m_lCurrentWnd, WM_PAINT, (WPARAM )0, (LPARAM )0 );

	// Get location of the observed window.
	if ( ::GetWindowRect(m_lCurrentWnd, &rc) == 0 )
		dwResult = GetLastError(); 

	longpoint = MAKELONG( rc.left + (rc.right - rc.left)/2, rc.top + (rc.bottom - rc.top)/2);
	longpoint = 0L;
	::SendMessage( m_lCurrentWnd, WM_LBUTTONDOWN, MK_LBUTTON, longpoint );
	::SleepEx(100, TRUE);
	::SendMessage( m_lCurrentWnd, WM_LBUTTONUP, MK_LBUTTON, longpoint );
}



// Group #1 : Set the caption on an object
// Event    : WM_SETTEXT, 0, TEXT
void CMySpyDlg::OnButtonSetCaption() 
{
//	::MessageBox(NULL, m_strSetCaption, "Stub for Enable Object", MB_OK);
	::SendMessage( m_lCurrentWnd, WM_SETTEXT, (WPARAM )0, (LPARAM )m_strSetCaption.GetBuffer(1024) );

}

void CMySpyDlg::OnUpdateSetCaption() 
{
	UpdateData(TRUE);	
}

// Group #2 : Bring a password, simply by sending events (not hooking the keyboard queue).
// Event    : several

void CMySpyDlg::OnButtonBringPassword() 
{
	::PostMessage( m_lCurrentWnd, EM_SETPASSWORDCHAR, 0, 0 );
	::PostMessage( m_lCurrentWnd, EM_SETSEL, 0, -1);
	::PostMessage( m_lCurrentWnd, WM_COPY, 0, 0);
	
	::PostMessage( m_lCurrentWnd, EM_SETPASSWORDCHAR, '*', 0 );
	::PostMessage( m_lCurrentWnd, EM_SETSEL, 0, 0);

	// Delete all of the text.
	m_cBringPassword.SetSel(0, -1);
	m_cBringPassword.Clear();
	m_cBringPassword.Paste();
}

// Group #3 : Execute at address
// Event    : WM_TIMER, 0, <address>. Newer service packs have a workaround this issue.
void CMySpyDlg::OnButtonExecuteAddress() 
{
//	::MessageBox(NULL, m_strExecuteAddress, "Stub for Execute Address", MB_OK);
	::PostMessage( m_lCurrentWnd, WM_TIMER, (WPARAM )0, (LPARAM )atol(m_strExecuteAddress) );
}

void CMySpyDlg::OnUpdateExecuteAddress() 
{
	UpdateData(TRUE);	
}

// Group #4 : Set spying window
// 
void CMySpyDlg::OnButtonSetSpyingWindow() 
{
	DWORD winHandle;
	
	sscanf( m_strSetWindow, "%X", &winHandle);
	if ( winHandle > 0 )
	{
		m_lCurrentWnd = (HWND )winHandle;
		m_lLastWnd = m_lCurrentWnd;
		m_bChasing = FALSE;
	}
}

void CMySpyDlg::OnUpdateEditSetWindow() 
{
	UpdateData(TRUE);	
}

void CMySpyDlg::OnDestroy() 
{
	CDialog::OnDestroy();
	
	UnhookWindowsHookEx(hKeyboardHook);

	delete m_lpCurrentClassName;
	delete m_lpCurrentWindowText;
}

void CMySpyDlg::RetrieveComputerUserName()
{
	const int BUFSIZE = 1025;
    LPTSTR lpszSystemInfo;      // pointer to system information string 
	DWORD cchBuff = BUFSIZE;    // size of computer or user name 
	TCHAR tchBuffer[BUFSIZE];   // buffer for string
 
	lpszSystemInfo = tchBuffer; 

	m_cstrCurrentUser += "\\\\";

	// Get the name of the computer. 
	if( GetComputerName(lpszSystemInfo, &cchBuff) ) 
		m_cstrCurrentUser += lpszSystemInfo;
	else
		m_cstrCurrentUser += "UNKNOWN";
 
	m_cstrCurrentUser += "\\";

	// Get the user name. 
	cchBuff = BUFSIZE; 
	if ( GetUserName(lpszSystemInfo, &cchBuff) ) 
		m_cstrCurrentUser += lpszSystemInfo;
	else
		m_cstrCurrentUser += "UNKNOWN";
}

void CMySpyDlg::OnLButtonDown(UINT nFlags, CPoint point) 
{
	RECT rc;
	DWORD result;

	// Find where the mouse pointer is.
	ClientToScreen(&point);
	
	// Get location of the crosshair icon.
	if ( ::GetWindowRect(hStatic, &rc) == 0 )
		result = GetLastError();

	if( ::PtInRect(&rc, point) )
	{
		::SetCursor( hCurCross );
		result = ::SendMessage (hStatic, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM )(HBITMAP )hIcoCrossHairOff);
		SetCapture();
		m_bChasing = true;
	}
		
	CDialog::OnLButtonDown(nFlags, point);
}

void CMySpyDlg::OnLButtonUp(UINT nFlags, CPoint point) 
{
	ReleaseTheCursor();
	
	CDialog::OnLButtonUp(nFlags, point);
}

void CMySpyDlg::OnMouseMove(UINT nFlags, CPoint point) 
{
	DWORD PID, TID;

	switch (m_bChasing)		// VC5 does not like breaks in if statements.
	{
	case TRUE:
		ClientToScreen(&point);
//		m_lCurrentWnd = ::WindowFromPoint(point);		// This makes invisible individual controls of windows.
		m_lCurrentWnd = SmallestWindowFromPoint(point);
	
		TID = ::GetWindowThreadProcessId (m_lCurrentWnd, &PID);

		if (GetCurrentProcessId () == PID)
			break;	

		if ( m_lLastWnd == m_lCurrentWnd )
			break;

		if ( m_lLastWnd )
			HighlightWindow(m_lLastWnd, FALSE);

		HighlightWindow(m_lCurrentWnd, TRUE);

		m_lLastWnd = m_lCurrentWnd;

		// Time to fill in the information boxes on the dialog box.
		m_cstrCurrentHWnd.Format("0x%x", (LONG )m_lCurrentWnd);

		::GetClassName(m_lCurrentWnd, m_lpCurrentClassName, m_ciNameSize);
		m_cstrCurrentClassName = m_lpCurrentClassName;

		::GetWindowText(m_lCurrentWnd, m_lpCurrentWindowText, m_ciNameSize);
		m_cstrCurrentText = m_lpCurrentWindowText;
		
		UpdateData(FALSE);
		break;
	default:
		;
	}

	CDialog::OnMouseMove(nFlags, point);
}

void CMySpyDlg::OnKillFocus(CWnd* pNewWnd) 
{
	CDialog::OnKillFocus(pNewWnd);
	
	ReleaseTheCursor();
}

void CMySpyDlg::ReleaseTheCursor()
{
	if( m_bChasing )
	{
		if( m_lLastWnd )
			HighlightWindow(m_lLastWnd, FALSE);
	
		m_lLastWnd = NULL;

		::SetCursor( hCurNormal );
		::SendMessage (hStatic, STM_SETIMAGE, IMAGE_BITMAP, (LPARAM) (HBITMAP)hIcoCrossHairOn);
		ReleaseCapture();
		m_bChasing = false;
	}
}

//-----------------------------------------------
// HighlightWindow
// Notice: from MSDN Spy Sample
//
void CMySpyDlg::HighlightWindow( HWND hwnd, BOOL fDraw )
{
#define DINV                3
	HDC hdc;
    RECT rc;
    BOOL bBorderOn;
    bBorderOn = fDraw;

    if (hwnd == NULL || !IsWindow(hwnd))
        return;

    hdc = ::GetWindowDC(hwnd);
    ::GetWindowRect(hwnd, &rc);
    ::OffsetRect(&rc, -rc.left, -rc.top);

    if (!IsRectEmpty(&rc))
    {
        PatBlt(hdc, rc.left, rc.top, rc.right - rc.left, DINV,  DSTINVERT);
        PatBlt(hdc, rc.left, rc.bottom - DINV, DINV,
            -(rc.bottom - rc.top - 2 * DINV), DSTINVERT);
        PatBlt(hdc, rc.right - DINV, rc.top + DINV, DINV,
            rc.bottom - rc.top - 2 * DINV, DSTINVERT);
        PatBlt(hdc, rc.right, rc.bottom - DINV, -(rc.right - rc.left),
            DINV, DSTINVERT);
    }

    ::ReleaseDC(hwnd, hdc);
} 

//-----------------------------------------------
// SmallestWindowFromPoint
// Notice: from PasswordSpy by Brian Friesen
//
// Find the smallest window still containing the point
//
// WindowFromPoint returns the first window in the Z-order ->
// if the password control is sorounded by a Group Box or some other control,
// WindowFromPoint returns the handle to the sorounding control instead
// to the password control.
//
HWND CMySpyDlg::SmallestWindowFromPoint( const POINT point )
{	
	RECT rect, rcTemp;
	HWND hParent, hWnd, hTemp;

	hWnd = ::WindowFromPoint( point );
	if( hWnd != NULL )
	{
		::GetWindowRect( hWnd, &rect );
		hParent = ::GetParent( hWnd );

		// Has window a parent?
		if( hParent != NULL )
		{
			// Search down the Z-Order
			hTemp = hWnd;
			do{
				hTemp = ::GetWindow( hTemp, GW_HWNDNEXT );

				// Search window contains the point, hase the same parent, and is visible?
				::GetWindowRect( hTemp, &rcTemp );
				if(::PtInRect(&rcTemp, point) && ::GetParent(hTemp) == hParent && ::IsWindowVisible(hTemp))
				{
					// Is it smaller?
					if(((rcTemp.right - rcTemp.left) * (rcTemp.bottom - rcTemp.top)) < ((rect.right - rect.left) * (rect.bottom - rect.top)))
					{
						// Found new smaller window!
						hWnd = hTemp;
						::GetWindowRect(hWnd, &rect);
					}
				}
			}while( hTemp != NULL );
		}
	}

	return hWnd;
}

