/* MySpyDlg.h - Demonstration application for sending windows events.
 * Copyright (c) 2001-2003 Simos Xenitellis <simos74@gmx.net>
 *
 * -----------------------------------------------------------------------
 * This program is free software; you can redistribute it and/or modify it
 * under the terms of the GNU General Public License as published by the
 * Free Software Foundation; either version 2 of the License, or (at your
 * option) any later version.
 *
 * This program is distributed in the hope that it will be useful, but
 * WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * General Public License for more details.
 *
 * The GNU General Public License is available from http://www.gnu.org/ or
 * the Free Software Foundation, Inc., 59 Temple Place - Suite 330, Boston,
 * MA 02111-1307, USA.
 * -----------------------------------------------------------------------
 */

// header file
//

#if !defined(AFX_MYSPYDLG_H__38F9D373_C70E_4D89_A7BF_126CFF7D7E08__INCLUDED_)
#define AFX_MYSPYDLG_H__38F9D373_C70E_4D89_A7BF_126CFF7D7E08__INCLUDED_

#if _MSC_VER >= 1000
#pragma once
#endif // _MSC_VER >= 1000

/////////////////////////////////////////////////////////////////////////////
// CMySpyDlg dialog

extern CMySpyApp theApp;

extern CString  message;
extern HHOOK	hKeyboardHook;
extern HCURSOR  hCurCross;
extern HCURSOR  hCurNormal;
extern HWND		hStatic;

class CMySpyDlg : public CDialog
{
// Construction
public:
	CMySpyDlg(CWnd* pParent = NULL);	// standard constructor

// Dialog Data
	//{{AFX_DATA(CMySpyDlg)
	enum { IDD = IDD_MYSPY_DIALOG };
	CEdit	m_cBringPassword;
	CString	m_cstrParentClassName;
	CString	m_cstrParentWindowHandle;
	CString	m_cstrParentWindowText;
	CString	m_cstrCurrentClassName;
	CString	m_cstrCurrentHWnd;
	CString	m_cstrCurrentText;
	CString	m_strExecuteAddress;
	CString	m_strSetCaption;
	CString	m_strSetWindow;
	CString	m_cstrCurrentUser;
	CString	m_cstrWinStationDesktop;
	//}}AFX_DATA

	// ClassWizard generated virtual function overrides
	//{{AFX_VIRTUAL(CMySpyDlg)
	protected:
	virtual void DoDataExchange(CDataExchange* pDX);	// DDX/DDV support
	//}}AFX_VIRTUAL

// Implementation
protected:
	UINT m_ciNameSize;

	LPTSTR m_lpCurrentWindowText;
	LPTSTR m_lpCurrentClassName;

	HWND m_lCurrentWnd;
	HWND m_lLastWnd;

	CPoint m_pMousePoint;
//	LPPOINT m_lpMouseLocation;

	UINT m_nTimer;
	HICON m_hIcon;

	BOOL m_bChasing;

	// Generated message map functions
	//{{AFX_MSG(CMySpyDlg)
	virtual BOOL OnInitDialog();
	afx_msg void OnSysCommand(UINT nID, LPARAM lParam);
	afx_msg void OnPaint();
	afx_msg HCURSOR OnQueryDragIcon();
	afx_msg void OnButtonCloseWindow();
	afx_msg void OnDestroy();
	afx_msg void OnButtonRevealpass();
	afx_msg void OnButtonSetpass();
	afx_msg void OnButtonBringPassword();
	afx_msg void OnButtonSetCaption();
	afx_msg void OnButtonFreezeWindow();
	afx_msg void OnButtonMeltWindow();
	afx_msg void OnButtonEnableObject();
	afx_msg void OnButtonDisableObject();
	afx_msg void OnButtonEnableAndClick();
	afx_msg void OnButtonExecuteAddress();
	afx_msg void OnUpdateExecuteAddress();
	afx_msg void OnUpdateSetCaption();
	afx_msg void OnButtonSetSpyingWindow();
	afx_msg void OnUpdateEditSetWindow();
	afx_msg void OnLButtonDown(UINT nFlags, CPoint point);
	afx_msg void OnLButtonUp(UINT nFlags, CPoint point);
	afx_msg void OnMouseMove(UINT nFlags, CPoint point);
	afx_msg void OnKillFocus(CWnd* pNewWnd);
	//}}AFX_MSG
	DECLARE_MESSAGE_MAP()
private:
	void RetrieveWinStationDesktop(void);
	void HighlightWindow( HWND hwnd, BOOL fDraw );
	void ReleaseTheCursor();
	CBitmap hIcoCrossHairOn;
	CBitmap hIcoCrossHairOff;
	void RetrieveComputerUserName(void);
	HWND SmallestWindowFromPoint(const POINT point);
};

//{{AFX_INSERT_LOCATION}}
// Microsoft Developer Studio will insert additional declarations immediately before the previous line.

#endif // !defined(AFX_MYSPYDLG_H__38F9D373_C70E_4D89_A7BF_126CFF7D7E08__INCLUDED_)
